//+------------------------------------------------------------------+
//|                                                        Bands.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 LightSeaGreen
#property indicator_color2 LightSeaGreen
#property indicator_color3 LightSeaGreen



#define MODE_Average           0
#define MODE_Variance          1
#define MODE_AverageDeviation  2
#define MODE_StandardDeviation 3
#define MODE_Skewness          4
#define MODE_Kurtosis          5




extern int    BandsPeriod     = 20;
extern int    Price           = 0;
extern int    Phase           = 0;
extern int    mode            = MODE_StandardDeviation;
extern double BandsDeviations = 2.0;





double MidleBuffer[];
double UpperBuffer[];
double LowerBuffer[];
double MovingBuffer[];



int init()
  {
   IndicatorDigits(6);
   IndicatorBuffers(4);
   SetIndexBuffer(0,MidleBuffer);  SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(1,UpperBuffer);  SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(2,LowerBuffer);  SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(3,MovingBuffer);
   
   mode = MathMax(MathMin(mode,5),0);

   return(0);
  }

   
int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
         
   for(i=limit; i>=0; i--)
   {
   MovingBuffer[i]   = iSmooth(iMA(NULL,0,1,0,MODE_SMA,Price,i),BandsPeriod,Phase,i);
   }
   for(i=limit; i>=0; i--)
   {
   double deviations = iCalc(MovingBuffer,BandsPeriod,mode,i);
   MidleBuffer[i]    = iMAOnArray(MovingBuffer,0,BandsPeriod,0,MODE_LWMA,i);
   UpperBuffer[i]    = MidleBuffer[i]+deviations*BandsDeviations;
   LowerBuffer[i]    = MidleBuffer[i]-deviations*BandsDeviations;
   }

   return(0);
  }
//+------------------------------------------------------------------+


double wrk[][10];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i)
{
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[0][k]=price; for(; k<10; k++) wrk[0][k]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax];
      double del2   = price - wrk[r-1][bsmin];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty] = MathAbs(del2); 
         wrk[r][vsum] =	wrk[r-1][vsum] + (wrk[r][volty]-wrk[r-forBar][volty])*div;
   
         //
         //
         //
         //
         //
   
         wrk[r][avolty] = wrk[r-1][avolty]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum]-wrk[r-1][avolty]);
            if (wrk[r][avolty] > 0)
               double dVolty = wrk[r][volty]/wrk[r][avolty]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax] = price; else wrk[r][bsmax] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin] = price; else wrk[r][bsmin] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0] = price + alpha*(wrk[r-1][0]-price);
         wrk[r][1] = (price - wrk[r][0])*(1-beta) + beta*wrk[r-1][1];
         wrk[r][2] = (wrk[r][0] + R*wrk[r][1]);
         wrk[r][3] = (wrk[r][2] - wrk[r-1][4])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3];
         wrk[r][4] = (wrk[r-1][4] + wrk[r][3]); 

   //
   //
   //
   //
   //

   return(wrk[r][4]);
}


double iCalc(double &array[], double cPeriod,int cMode, int i)
{
   double average=0;
      for (int k=0; k<cPeriod; k++)     average += array[i+k];
                                        average /= cPeriod;
      if (cMode == MODE_Average) return(average);
      
   //
   //
   //
   //
   //
 
   double adeviation = 0;
   double deviation  = 0;
   double variance   = 0;
   double skewness   = 0;
   double kurtosis   = 0;
   double sumDiff    = 0;
     
      for (k=0; k<cPeriod; k++)
      {
         double d = array[i+k]-average;

         //
         //
         //
         //
         //
         
            adeviation += MathAbs(d);
            sumDiff    += d;
            variance   += d*d;
            skewness   += d*d*d;
            kurtosis   += d*d*d*d;
      }

   //
   //
   //
   //
   //
         
   adeviation  = adeviation/cPeriod;   
   variance    = (variance*cPeriod-sumDiff*sumDiff)/(cPeriod*(cPeriod-1.0));
   deviation   = MathSqrt(variance);
   if (variance != 0)
   {
      skewness = skewness/(cPeriod*variance*deviation);
      kurtosis = kurtosis/(cPeriod*variance*variance)-3.0;
   }
   else
   {
      skewness = 0;
      kurtosis = 0;
   }

   //
   //
   //
   //
   //
   
   switch (cMode)
   {
      case MODE_AverageDeviation:  return(adeviation);
      case MODE_StandardDeviation: return(deviation);
      case MODE_Variance:          return(variance);
      case MODE_Skewness:          return(skewness);
      case MODE_Kurtosis:          return(kurtosis);
   }
}

